]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: more style fixes
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115 unset NAME
116
117 test_require_emacs () {
118     test_require_external_prereq emacs
119     test_require_external_prereq ${TEST_EMACSCLIENT}
120     test_require_external_prereq dtach
121 }
122
123 add_gnupg_home () {
124     [ -e "${GNUPGHOME}/gpg.conf" ] && return
125     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
126     at_exit_function _gnupg_exit
127     mkdir -p -m 0700 "$GNUPGHOME"
128     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
129     test_debug "cat $GNUPGHOME/import.log"
130     if (gpg --quick-random --version >/dev/null 2>&1) ; then
131         echo quick-random >> "$GNUPGHOME"/gpg.conf
132     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
133         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
134     fi
135     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
136
137     # Change this if we ship a new test key
138     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
139     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
140     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
141 }
142
143 add_gpgsm_home () {
144     local fpr
145     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
146     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
147     at_exit_function _gnupg_exit
148     mkdir -p -m 0700 "$GNUPGHOME"
149     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
150         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
151         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
152               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
153     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
154     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
155     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
156     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
157     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
158     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
159               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
160     test_debug "cat $GNUPGHOME/import.log"
161 }
162
163 # Each test should start with something like this, after copyright notices:
164 #
165 # test_description='Description of this test...
166 # This test checks if command xyzzy does the right thing...
167 # '
168 # . ./test-lib.sh || exit 1
169
170 color=maybe
171
172 while test "$#" -ne 0
173 do
174         case "$1" in
175         -d|--debug)
176                 debug=t; shift ;;
177         -i|--immediate)
178                 immediate=t; shift ;;
179         -h|--help)
180                 help=t; shift ;;
181         -v|--verbose)
182                 verbose=t; shift ;;
183         -q|--quiet)
184                 quiet=t; shift ;;
185         --with-dashes)
186                 with_dashes=t; shift ;;
187         --no-color)
188                 color=; shift ;;
189         --no-python)
190                 # noop now...
191                 shift ;;
192         --valgrind)
193                 valgrind=t; verbose=t; shift ;;
194         --tee)
195                 shift ;; # was handled already
196         *)
197                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
198         esac
199 done
200
201 if test -n "$debug"; then
202     print_subtest () {
203         printf " %-4s" "[$((test_count - 1))]"
204     }
205 else
206     print_subtest () {
207         true
208     }
209 fi
210
211 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
212
213 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
214                 TERM=$ORIGINAL_TERM &&
215                 export TERM &&
216                 tput bold
217                 tput setaf
218                 tput sgr0
219         ) >/dev/null 2>&1
220 then
221         color=t
222 else
223         color=
224 fi
225
226 if test -n "$color"; then
227         say_color () {
228                 (
229                 TERM=$ORIGINAL_TERM
230                 export TERM
231                 case "$1" in
232                         error) tput bold; tput setaf 1;; # bold red
233                         skip)  tput bold; tput setaf 2;; # bold green
234                         pass)  tput setaf 2;;            # green
235                         info)  tput setaf 3;;            # brown
236                         *) test -n "$quiet" && return;;
237                 esac
238                 shift
239                 printf " "
240                 printf "$@"
241                 tput sgr0
242                 print_subtest
243                 )
244         }
245 else
246         say_color() {
247                 test -z "$1" && test -n "$quiet" && return
248                 shift
249                 printf " "
250                 printf "$@"
251                 print_subtest
252         }
253 fi
254
255 error () {
256         say_color error "error: $*\n"
257         GIT_EXIT_OK=t
258         exit 1
259 }
260
261 say () {
262         say_color info "$*"
263 }
264
265 test "${test_description}" != "" ||
266 error "Test script did not set test_description."
267
268 if test "$help" = "t"
269 then
270         echo "Tests ${test_description}"
271         exit 0
272 fi
273
274 test_description_printed=
275 print_test_description () {
276         test -z "$test_description_printed" || return 0
277         echo
278         echo $this_test: "Testing ${test_description}"
279         test_description_printed=1
280 }
281 if [ -z "$NOTMUCH_TEST_QUIET" ]
282 then
283         print_test_description
284 fi
285
286 test_failure=0
287 test_count=0
288 test_fixed=0
289 test_broken=0
290 test_success=0
291
292 declare -a _exit_functions=()
293
294 at_exit_function () {
295         _exit_functions=($1 ${_exit_functions[@]/$1})
296 }
297
298 rm_exit_function () {
299         _exit_functions=(${_exit_functions[@]/$1})
300 }
301
302 _exit_common () {
303         code=$?
304         trap - EXIT
305         set +ex
306         for _fn in ${_exit_functions[@]}; do $_fn; done
307         rm -rf "$TEST_TMPDIR"
308 }
309
310 trap_exit () {
311         _exit_common
312         if test -n "$GIT_EXIT_OK"
313         then
314                 exit $code
315         else
316                 exec >&6
317                 say_color error '%-6s' FATAL
318                 echo " $test_subtest_name"
319                 echo
320                 echo "Unexpected exit while executing $0. Exit code $code."
321                 exit 1
322         fi
323 }
324
325 trap_signal () {
326         _exit_common
327         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
328         exit $code
329 }
330
331 die () {
332         _exit_common
333         exec >&6
334         say_color error '%-6s' FATAL
335         echo " $*"
336         echo
337         echo "Unexpected exit while executing $0."
338         exit 1
339 }
340
341 GIT_EXIT_OK=
342 # Note: TEST_TMPDIR *NOT* exported!
343 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
344 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
345 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
346 trap 'trap_exit' EXIT
347 trap 'trap_signal' HUP INT TERM
348
349 # Deliver a message with emacs and add it to the database
350 #
351 # Uses emacs to generate and deliver a message to the mail store.
352 # Accepts arbitrary extra emacs/elisp functions to modify the message
353 # before sending, which is useful to doing things like attaching files
354 # to the message and encrypting/signing.
355 emacs_deliver_message () {
356     local subject body smtp_dummy_pid smtp_dummy_port
357     subject="$1"
358     body="$2"
359     shift 2
360     # before we can send a message, we have to prepare the FCC maildir
361     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
362     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
363     smtp_dummy_pid= smtp_dummy_port=
364     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
365     test -n "$smtp_dummy_pid" || return 1
366     test -n "$smtp_dummy_port" || return 1
367
368     test_emacs \
369         "(let ((message-send-mail-function 'message-smtpmail-send-it)
370                (mail-host-address \"example.com\")
371                (smtpmail-smtp-server \"localhost\")
372                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
373            (notmuch-mua-mail)
374            (message-goto-to)
375            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
376            (message-goto-subject)
377            (insert \"${subject}\")
378            (message-goto-body)
379            (insert \"${body}\")
380            $*
381            (notmuch-mua-send-and-exit))"
382
383     # In case message was sent properly, client waits for confirmation
384     # before exiting and resuming control here; therefore making sure
385     # that server exits by sending (KILL) signal to it is safe.
386     kill -9 $smtp_dummy_pid
387     notmuch new >/dev/null
388 }
389
390 # Pretend to deliver a message with emacs. Really save it to a file
391 # and add it to the database
392 #
393 # Uses emacs to generate and deliver a message to the mail store.
394 # Accepts arbitrary extra emacs/elisp functions to modify the message
395 # before sending, which is useful to doing things like attaching files
396 # to the message and encrypting/signing.
397 #
398 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
399 # at the head of the argument list, they are sent directly to "notmuch
400 # new" after message delivery
401 emacs_fcc_message () {
402     local nmn_args subject body
403     nmn_args=''
404     while [[ "$1" =~ ^-- ]]; do
405         nmn_args="$nmn_args $1"
406         shift
407     done
408     subject="$1"
409     body="$2"
410     shift 2
411     # before we can send a message, we have to prepare the FCC maildir
412     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
413
414     test_emacs \
415         "(let ((message-send-mail-function (lambda () t))
416                (mail-host-address \"example.com\"))
417            (notmuch-mua-mail)
418            (message-goto-to)
419            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
420            (message-goto-subject)
421            (insert \"${subject}\")
422            (message-goto-body)
423            (insert \"${body}\")
424            $*
425            (let ((mml-secure-smime-sign-with-sender t)
426                  (mml-secure-openpgp-sign-with-sender t))
427              (notmuch-mua-send-and-exit)))" || return 1
428     notmuch new $nmn_args >/dev/null
429 }
430
431 # Add an existing, fixed corpus of email to the database.
432 #
433 # $1 is the corpus dir under corpora to add, using "default" if unset.
434 #
435 # The default corpus is based on about 50 messages from early in the
436 # history of the notmuch mailing list, which allows for reliably
437 # testing commands that need to operate on a not-totally-trivial
438 # number of messages.
439 add_email_corpus () {
440     local corpus
441     corpus=${1:-default}
442
443     rm -rf ${MAIL_DIR}
444     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
445     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
446 }
447
448 test_begin_subtest () {
449     if [ -n "$inside_subtest" ]; then
450         exec 1>&6 2>&7          # Restore stdout and stderr
451         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
452     fi
453     test_subtest_name="$1"
454     test_reset_state_
455     # Redirect test output to the previously prepared file descriptors
456     # 3 and 4 (see below)
457     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
458     exec >&3 2>&4
459     inside_subtest=t
460 }
461
462 # Pass test if two arguments match
463 #
464 # Note: Unlike all other test_expect_* functions, this function does
465 # not accept a test name. Instead, the caller should call
466 # test_begin_subtest before calling this function in order to set the
467 # name.
468 test_expect_equal () {
469         local output expected testname
470         exec 1>&6 2>&7          # Restore stdout and stderr
471         if [ -z "$inside_subtest" ]; then
472                 error "bug in the test script: test_expect_equal without test_begin_subtest"
473         fi
474         inside_subtest=
475         test "$#" = 2 ||
476         error "bug in the test script: not 2 parameters to test_expect_equal"
477
478         output="$1"
479         expected="$2"
480         if ! test_skip "$test_subtest_name"
481         then
482                 if [ "$output" = "$expected" ]; then
483                         test_ok_
484                 else
485                         testname=$this_test.$test_count
486                         echo "$expected" > $testname.expected
487                         echo "$output" > $testname.output
488                         test_failure_ "$(diff -u $testname.expected $testname.output)"
489                 fi
490     fi
491 }
492
493 # Like test_expect_equal, but takes two filenames.
494 test_expect_equal_file () {
495         local file1 file2 testname basename1 basename2
496         exec 1>&6 2>&7          # Restore stdout and stderr
497         if [ -z "$inside_subtest" ]; then
498                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
499         fi
500         inside_subtest=
501         test "$#" = 2 ||
502         error "bug in the test script: not 2 parameters to test_expect_equal_file"
503
504         file1="$1"
505         file2="$2"
506         if ! test_skip "$test_subtest_name"
507         then
508                 if diff -q "$file1" "$file2" >/dev/null ; then
509                         test_ok_
510                 else
511                         testname=$this_test.$test_count
512                         basename1=`basename "$file1"`
513                         basename2=`basename "$file2"`
514                         cp "$file1" "$testname.$basename1"
515                         cp "$file2" "$testname.$basename2"
516                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
517                 fi
518     fi
519 }
520
521 # Like test_expect_equal, but arguments are JSON expressions to be
522 # canonicalized before diff'ing.  If an argument cannot be parsed, it
523 # is used unchanged so that there's something to diff against.
524 test_expect_equal_json () {
525     local script output expected
526     # The test suite forces LC_ALL=C, but this causes Python 3 to
527     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
528     # override Python's stdio encoding defaults.
529     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
530     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
531         || echo "$1")
532     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
533         || echo "$2")
534     shift 2
535     test_expect_equal "$output" "$expected" "$@"
536 }
537
538 # Ensure that the argument is valid JSON data.
539 test_valid_json () {
540     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
541     test_expect_equal "$?" 0
542 }
543
544 # Sort the top-level list of JSON data from stdin.
545 test_sort_json () {
546     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
547         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
548 }
549
550 # test for json objects:
551 # read the source of test/json_check_nodes.py (or the output when
552 # invoking it without arguments) for an explanation of the syntax.
553 test_json_nodes () {
554         local output
555         exec 1>&6 2>&7          # Restore stdout and stderr
556         if [ -z "$inside_subtest" ]; then
557                 error "bug in the test script: test_json_eval without test_begin_subtest"
558         fi
559         inside_subtest=
560         test "$#" > 0 ||
561             error "bug in the test script: test_json_nodes needs at least 1 parameter"
562
563         if ! test_skip "$test_subtest_name"
564         then
565             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
566                 if [ "$?" = 0 ]
567                 then
568                         test_ok_
569                 else
570                         test_failure_ "$output"
571                 fi
572         fi
573 }
574
575 test_emacs_expect_t () {
576         local result
577         test "$#" = 1 ||
578         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
579         if [ -z "$inside_subtest" ]; then
580                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
581         fi
582
583         # Run the test.
584         if ! test_skip "$test_subtest_name"
585         then
586                 test_emacs "(notmuch-test-run $1)" >/dev/null
587
588                 # Restore state after the test.
589                 exec 1>&6 2>&7          # Restore stdout and stderr
590                 inside_subtest=
591
592                 # test_emacs may update missing external prerequisites
593                 test_check_missing_external_prereqs_ "$test_subtest_name" && return
594
595                 # Report success/failure.
596                 result=$(cat OUTPUT)
597                 if [ "$result" = t ]
598                 then
599                         test_ok_
600                 else
601                         test_failure_ "${result}"
602                 fi
603         else
604                 # Restore state after the (non) test.
605                 exec 1>&6 2>&7          # Restore stdout and stderr
606                 inside_subtest=
607         fi
608 }
609
610 NOTMUCH_NEW () {
611     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
612 }
613
614 NOTMUCH_DUMP_TAGS () {
615     # this relies on the default format being batch-tag, otherwise some tests will break
616     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
617 }
618
619 notmuch_drop_mail_headers () {
620     $NOTMUCH_PYTHON -c '
621 import email, sys
622 msg = email.message_from_file(sys.stdin)
623 for hdr in sys.argv[1:]: del msg[hdr]
624 print(msg.as_string(False))
625 ' "$@"
626 }
627
628 notmuch_exception_sanitize () {
629     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
630 }
631
632 notmuch_search_sanitize () {
633     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
634 }
635
636 notmuch_search_files_sanitize () {
637     notmuch_dir_sanitize
638 }
639
640 notmuch_dir_sanitize () {
641     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
642 }
643
644 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
645 notmuch_show_sanitize () {
646     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
647 }
648 notmuch_show_sanitize_all () {
649     sed \
650         -e 's| filename:.*| filename:XXXXX|' \
651         -e 's| id:[^ ]* | id:XXXXX |' | \
652         notmuch_date_sanitize
653 }
654
655 notmuch_json_show_sanitize () {
656     sed \
657         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
658         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
659         -e 's|"filename": "signature.asc",||g' \
660         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
661         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
662         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
663 }
664
665 notmuch_emacs_error_sanitize () {
666     local command
667     command=$1
668     shift
669     for file in "$@"; do
670         echo "=== $file ==="
671         cat "$file"
672     done | sed \
673         -e 's/^\[.*\]$/[XXX]/' \
674         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
675 }
676
677 notmuch_date_sanitize () {
678     sed \
679         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
680 }
681
682 notmuch_uuid_sanitize () {
683     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
684 }
685
686 notmuch_built_with_sanitize () {
687     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
688 }
689
690 notmuch_passwd_sanitize () {
691     ${NOTMUCH_PYTHON} -c'
692 import os, sys, pwd, socket
693
694 pw = pwd.getpwuid(os.getuid())
695 user = pw.pw_name
696 name = pw.pw_gecos.partition(",")[0]
697 fqdn = socket.getaddrinfo(socket.gethostname(), 0, 0, socket.SOCK_STREAM, 0, socket.AI_CANONNAME)[0][3]
698
699 for l in sys.stdin:
700     if user:
701         l = l.replace(user, "USERNAME")
702     if fqdn:
703         l = l.replace(fqdn, "FQDN").replace(".(none)","")
704     if name:
705         l = l.replace(name, "USER_FULL_NAME")
706     sys.stdout.write(l)
707 '
708 }
709
710 notmuch_config_sanitize () {
711     notmuch_dir_sanitize | notmuch_built_with_sanitize
712 }
713
714 notmuch_show_part () {
715     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
716 }
717
718 # End of notmuch helper functions
719
720 # Use test_set_prereq to tell that a particular prerequisite is available.
721 #
722 # The prerequisite can later be checked for by using test_have_prereq.
723 #
724 # The single parameter is the prerequisite tag (a simple word, in all
725 # capital letters by convention).
726
727 test_set_prereq () {
728         satisfied="$satisfied$1 "
729 }
730 satisfied=" "
731
732 test_have_prereq () {
733         case $satisfied in
734         *" $1 "*)
735                 : yes, have it ;;
736         *)
737                 ! : nope ;;
738         esac
739 }
740
741 declare -A test_missing_external_prereq_
742 declare -A test_subtest_missing_external_prereq_
743
744 # declare prerequisite for the given external binary
745 test_declare_external_prereq () {
746         local binary
747         binary="$1"
748         test "$#" = 2 && name=$2 || name="$binary(1)"
749
750         if ! hash $binary 2>/dev/null; then
751                 test_missing_external_prereq_["${binary}"]=t
752                 eval "
753 $binary () {
754         test_subtest_missing_external_prereq_[\"${name}\"]=t
755         false
756 }"
757         fi
758 }
759
760 # Explicitly require external prerequisite.  Useful when binary is
761 # called indirectly (e.g. from emacs).
762 # Returns success if dependency is available, failure otherwise.
763 test_require_external_prereq () {
764         local binary
765         binary="$1"
766         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
767                 # dependency is missing, call the replacement function to note it
768                 eval "$binary"
769         else
770                 true
771         fi
772 }
773
774 # You are not expected to call test_ok_ and test_failure_ directly, use
775 # the text_expect_* functions instead.
776
777 test_ok_ () {
778         if test "$test_subtest_known_broken_" = "t"; then
779                 test_known_broken_ok_
780                 return
781         fi
782         test_success=$(($test_success + 1))
783         if test -n "$NOTMUCH_TEST_QUIET"; then
784                 return 0
785         fi
786         say_color pass "%-6s" "PASS"
787         echo " $test_subtest_name"
788 }
789
790 test_failure_ () {
791         print_test_description
792         if test "$test_subtest_known_broken_" = "t"; then
793                 test_known_broken_failure_ "$@"
794                 return
795         fi
796         test_failure=$(($test_failure + 1))
797         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
798         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
799         return 1
800 }
801
802 test_failure_message_ () {
803         say_color error "%-6s" "$1"
804         echo " $2"
805         shift 2
806         if [ "$#" != "0" ]; then
807                 echo "$@" | sed -e 's/^/        /'
808         fi
809         if test "$verbose" != "t"; then cat test.output; fi
810 }
811
812 test_known_broken_ok_ () {
813         test_reset_state_
814         test_fixed=$(($test_fixed+1))
815         say_color pass "%-6s" "FIXED"
816         echo " $test_subtest_name"
817 }
818
819 test_known_broken_failure_ () {
820         test_reset_state_
821         test_broken=$(($test_broken+1))
822         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
823                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
824         else
825                 test_failure_message_ "BROKEN" "$test_subtest_name"
826         fi
827         return 1
828 }
829
830 test_debug () {
831         test "$debug" = "" || eval "$1"
832 }
833
834 test_run_ () {
835         test_cleanup=:
836         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
837         eval >&3 2>&4 "$1"
838         eval_ret=$?
839         eval >&3 2>&4 "$test_cleanup"
840         return 0
841 }
842
843 test_skip () {
844         test_count=$(($test_count+1))
845         to_skip=
846         for skp in $NOTMUCH_SKIP_TESTS
847         do
848                 case $this_test.$test_count in
849                 $skp)
850                         to_skip=t
851                         break
852                 esac
853                 case $this_test_bare.$test_count in
854                 $skp)
855                         to_skip=t
856                         break
857                 esac
858         done
859         case "$to_skip" in
860         t)
861                 test_report_skip_ "$@"
862                 ;;
863         *)
864                 test_check_missing_external_prereqs_ "$@"
865                 ;;
866         esac
867 }
868
869 test_check_missing_external_prereqs_ () {
870         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
871                 say_color skip >&1 "missing prerequisites: "
872                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
873                 test_report_skip_ "$@"
874         else
875                 false
876         fi
877 }
878
879 test_report_skip_ () {
880         test_reset_state_
881         say_color skip >&3 "skipping test:"
882         echo " $@" >&3
883         say_color skip "%-6s" "SKIP"
884         echo " $1"
885 }
886
887 test_subtest_known_broken () {
888         test_subtest_known_broken_=t
889 }
890
891 test_expect_success () {
892         exec 1>&6 2>&7          # Restore stdout and stderr
893         if [ -z "$inside_subtest" ]; then
894                 error "bug in the test script: test_expect_success without test_begin_subtest"
895         fi
896         inside_subtest=
897         test "$#" = 1 ||
898         error "bug in the test script: not 1 parameters to test_expect_success"
899
900         if ! test_skip "$test_subtest_name"
901         then
902                 test_run_ "$1"
903                 run_ret="$?"
904                 # test_run_ may update missing external prerequisites
905                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
906                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
907                 then
908                         test_ok_
909                 else
910                         test_failure_ "$1"
911                 fi
912         fi
913 }
914
915 test_expect_code () {
916         exec 1>&6 2>&7          # Restore stdout and stderr
917         if [ -z "$inside_subtest" ]; then
918                 error "bug in the test script: test_expect_code without test_begin_subtest"
919         fi
920         inside_subtest=
921         test "$#" = 2 ||
922         error "bug in the test script: not 2 parameters to test_expect_code"
923
924         if ! test_skip "$test_subtest_name"
925         then
926                 test_run_ "$2"
927                 run_ret="$?"
928                 # test_run_ may update missing external prerequisites,
929                 test_check_missing_external_prereqs_ "$test_subtest_name" ||
930                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
931                 then
932                         test_ok_
933                 else
934                         test_failure_ "exit code $eval_ret, expected $1" "$2"
935                 fi
936         fi
937 }
938
939 # This is not among top-level (test_expect_success)
940 # but is a prefix that can be used in the test script, like:
941 #
942 #       test_expect_success 'complain and die' '
943 #           do something &&
944 #           do something else &&
945 #           test_must_fail git checkout ../outerspace
946 #       '
947 #
948 # Writing this as "! git checkout ../outerspace" is wrong, because
949 # the failure could be due to a segv.  We want a controlled failure.
950
951 test_must_fail () {
952         "$@"
953         test $? -gt 0 -a $? -le 129 -o $? -gt 192
954 }
955
956 # test_cmp is a helper function to compare actual and expected output.
957 # You can use it like:
958 #
959 #       test_expect_success 'foo works' '
960 #               echo expected >expected &&
961 #               foo >actual &&
962 #               test_cmp expected actual
963 #       '
964 #
965 # This could be written as either "cmp" or "diff -u", but:
966 # - cmp's output is not nearly as easy to read as diff -u
967 # - not all diff versions understand "-u"
968
969 test_cmp () {
970         $GIT_TEST_CMP "$@"
971 }
972
973 # This function can be used to schedule some commands to be run
974 # unconditionally at the end of the test to restore sanity:
975 #
976 #       test_expect_success 'test core.capslock' '
977 #               git config core.capslock true &&
978 #               test_when_finished "git config --unset core.capslock" &&
979 #               hello world
980 #       '
981 #
982 # That would be roughly equivalent to
983 #
984 #       test_expect_success 'test core.capslock' '
985 #               git config core.capslock true &&
986 #               hello world
987 #               git config --unset core.capslock
988 #       '
989 #
990 # except that the greeting and config --unset must both succeed for
991 # the test to pass.
992
993 test_when_finished () {
994         test_cleanup="{ $*
995                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
996 }
997
998 test_done () {
999         GIT_EXIT_OK=t
1000         test_results_dir="$TEST_DIRECTORY/test-results"
1001         mkdir -p "$test_results_dir"
1002         test_results_path="$test_results_dir/$this_test"
1003
1004         echo "total $test_count" >> $test_results_path
1005         echo "success $test_success" >> $test_results_path
1006         echo "fixed $test_fixed" >> $test_results_path
1007         echo "broken $test_broken" >> $test_results_path
1008         echo "failed $test_failure" >> $test_results_path
1009         echo "" >> $test_results_path
1010
1011         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1012
1013         if [ "$test_failure" = "0" ]; then
1014             if [ "$test_broken" = "0" ]; then
1015                 rm -rf "$remove_tmp"
1016             fi
1017             exit 0
1018         else
1019             exit 1
1020         fi
1021 }
1022
1023 emacs_generate_script () {
1024         # Construct a little test script here for the benefit of the user,
1025         # (who can easily run "run_emacs" to get the same emacs environment
1026         # for investigating any failures).
1027         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1028 #!/bin/sh
1029 export PATH=$PATH
1030 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1031
1032 # Here's what we are using here:
1033 #
1034 # --quick               Use minimal customization. This implies --no-init-file,
1035 #                       --no-site-file and (emacs 24) --no-site-lisp
1036 #
1037 # --directory           Ensure that the local elisp sources are found
1038 #
1039 # --load                Force loading of notmuch.el and test-lib.el
1040
1041 exec ${TEST_EMACS} --quick \
1042         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1043         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1044         "\$@"
1045 EOF
1046         chmod a+x "$TMP_DIRECTORY/run_emacs"
1047 }
1048
1049 test_emacs () {
1050         # test dependencies beforehand to avoid the waiting loop below
1051         missing_dependencies=
1052         test_require_external_prereq dtach || missing_dependencies=1
1053         test_require_external_prereq emacs || missing_dependencies=1
1054         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1055         test -z "$missing_dependencies" || return
1056
1057         if [ -z "$EMACS_SERVER" ]; then
1058                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1059                 if [ -f "$emacs_tests" ]; then
1060                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1061                 else
1062                         load_emacs_tests=
1063                 fi
1064                 server_name="notmuch-test-suite-$$"
1065                 # start a detached session with an emacs server
1066                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1067                 # or unknown) is given to dtach which assumes a minimally
1068                 # VT100-compatible terminal -- and emacs inherits that
1069                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1070                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1071                                 --no-window-system \
1072                                 $load_emacs_tests \
1073                                 --eval '(setq server-name \"$server_name\")' \
1074                                 --eval '(server-start)' \
1075                                 --eval '(orphan-watchdog $$)'" || return
1076                 EMACS_SERVER="$server_name"
1077                 # wait until the emacs server is up
1078                 until test_emacs '()' >/dev/null 2>/dev/null; do
1079                         sleep 1
1080                 done
1081         fi
1082
1083         # Clear test-output output file.  Most Emacs tests end with a
1084         # call to (test-output).  If the test code fails with an
1085         # exception before this call, the output file won't get
1086         # updated.  Since we don't want to compare against an output
1087         # file from another test, so start out with an empty file.
1088         rm -f OUTPUT
1089         touch OUTPUT
1090
1091         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1092 }
1093
1094 test_python () {
1095     # Note: if there is need to print debug information from python program,
1096     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1097     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1098         $NOTMUCH_PYTHON -B - > OUTPUT
1099 }
1100
1101 test_C () {
1102     local exec_file test_file
1103     exec_file="test${test_count}"
1104     test_file="${exec_file}.c"
1105     cat > ${test_file}
1106     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1107     echo "== stdout ==" > OUTPUT.stdout
1108     echo "== stderr ==" > OUTPUT.stderr
1109     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1110     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize > OUTPUT
1111 }
1112
1113 make_shim () {
1114     local base_name test_file shim_file
1115     base_name="$1"
1116     test_file="${base_name}.c"
1117     shim_file="${base_name}.so"
1118     cat > ${test_file}
1119     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1120 }
1121
1122 notmuch_with_shim () {
1123     local base_name shim_file
1124     base_name="$1"
1125     shift
1126     shim_file="${base_name}.so"
1127     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
1128 }
1129
1130 # Creates a script that counts how much time it is executed and calls
1131 # notmuch.  $notmuch_counter_command is set to the path to the
1132 # generated script.  Use notmuch_counter_value() function to get the
1133 # current counter value.
1134 notmuch_counter_reset () {
1135         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1136         if [ ! -x "$notmuch_counter_command" ]; then
1137                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1138                 cat >"$notmuch_counter_command" <<EOF || return
1139 #!/bin/sh
1140
1141 read count < "$notmuch_counter_state_path"
1142 echo \$((count + 1)) > "$notmuch_counter_state_path"
1143
1144 exec notmuch "\$@"
1145 EOF
1146                 chmod +x "$notmuch_counter_command" || return
1147         fi
1148
1149         echo 0 > "$notmuch_counter_state_path"
1150 }
1151
1152 # Returns the current notmuch counter value.
1153 notmuch_counter_value () {
1154         if [ -r "$notmuch_counter_state_path" ]; then
1155                 read count < "$notmuch_counter_state_path"
1156         else
1157                 count=0
1158         fi
1159         echo $count
1160 }
1161
1162 test_reset_state_ () {
1163         test -z "$test_init_done_" && test_init_
1164
1165         test_subtest_known_broken_=
1166         test_subtest_missing_external_prereq_=()
1167 }
1168
1169 # called once before the first subtest
1170 test_init_ () {
1171         test_init_done_=t
1172
1173         # skip all tests if there were external prerequisites missing during init
1174         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1175 }
1176
1177
1178 # Where to run the tests
1179 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1180
1181 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1182
1183 emacs_generate_script
1184
1185
1186 # Use -P to resolve symlinks in our working directory so that the cwd
1187 # in subprocesses like git equals our $PWD (for pathname comparisons).
1188 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1189
1190 if test "$verbose" = "t"
1191 then
1192         exec 4>&2 3>&1
1193 else
1194         exec 4>test.output 3>&4
1195 fi
1196
1197 for skp in $NOTMUCH_SKIP_TESTS
1198 do
1199         to_skip=
1200         for skp in $NOTMUCH_SKIP_TESTS
1201         do
1202                 case "$this_test" in
1203                 $skp)
1204                         to_skip=t
1205                         break
1206                 esac
1207                 case "$this_test_bare" in
1208                 $skp)
1209                         to_skip=t
1210                         break
1211                 esac
1212         done
1213         case "$to_skip" in
1214         t)
1215                 say_color skip >&3 "skipping test $this_test altogether"
1216                 say_color skip "skip all tests in $this_test"
1217                 test_done
1218         esac
1219 done
1220
1221 # Provide an implementation of the 'yes' utility
1222 yes () {
1223         if test $# = 0
1224         then
1225                 y=y
1226         else
1227                 y="$*"
1228         fi
1229
1230         while echo "$y"
1231         do
1232                 :
1233         done
1234 }
1235
1236 # Fix some commands on Windows
1237 case $(uname -s) in
1238 *MINGW*)
1239         # Windows has its own (incompatible) sort and find
1240         sort () {
1241                 /usr/bin/sort "$@"
1242         }
1243         find () {
1244                 /usr/bin/find "$@"
1245         }
1246         sum () {
1247                 md5sum "$@"
1248         }
1249         # git sees Windows-style pwd
1250         pwd () {
1251                 builtin pwd -W
1252         }
1253         # no POSIX permissions
1254         # backslashes in pathspec are converted to '/'
1255         # exec does not inherit the PID
1256         ;;
1257 *)
1258         test_set_prereq POSIXPERM
1259         test_set_prereq BSLASHPSPEC
1260         test_set_prereq EXECKEEPSPID
1261         ;;
1262 esac
1263
1264 test -z "$NO_PERL" && test_set_prereq PERL
1265 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1266
1267 # test whether the filesystem supports symbolic links
1268 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1269 rm -f y
1270
1271 # declare prerequisites for external binaries used in tests
1272 test_declare_external_prereq dtach
1273 test_declare_external_prereq emacs
1274 test_declare_external_prereq ${TEST_EMACSCLIENT}
1275 test_declare_external_prereq ${TEST_GDB}
1276 test_declare_external_prereq gpg
1277 test_declare_external_prereq openssl
1278 test_declare_external_prereq gpgsm
1279 test_declare_external_prereq ${NOTMUCH_PYTHON}
1280 test_declare_external_prereq xapian-metadata
1281 test_declare_external_prereq xapian-delve